<?php
//
//  検索結果の表示
//  引数：ページ番号
//
function    zip_display($page)
{
    if (DEBUG)  {
        print "zip_display($page)<br>\n";
    }
    foreach (array('type', 'zip7', 'pref_j', 'city_j', 'count') as $item)  {
        if (isset($_POST[$item]))   {
            $$item = $_POST[$item];
        } else  {
            $$item = '';
        }
    }
    try {
        $db = new PDO(DSN);
    }
    catch(PDOException $e)  {
        die($e->getMessage());  //  異常終了
    }
    $select_phrase = "SELECT zip7,pref_j,city_j,town_j FROM zip ";
    if ($type == 1) {       //  郵便番号で検索
        $where_clause = "WHERE zip7 LIKE '$zip7%'";
    } else  {               //  住所で検索
        $where_clause = "WHERE 0=0";
        if (strlen($pref_j) > 0)  {
            $where_clause .= " AND pref_j = '$pref_j'";
        }
        if (strlen($city_j) > 0)  {
            $where_clause .= " AND city_j = '$city_j'";
        }
    }
    //
    //  新規条件指定時（セッションデータとして保存）
    //
    if ($page == 0) {
        $sql = "SELECT COUNT(*) FROM zip " . $where_clause;
        $stmt = $db->prepare($sql); //  SQL発行準備
        $stmt->execute();           //  SQL実行
        $ar = $stmt->fetchAll(PDO::FETCH_COLUMN);
        $count = $ar[0]['count'];   //  新しい条件に該当する件数
        $_SESSION['type']   = $type;
        $_SESSION['zip7']   = $zip7;
        $_SESSION['pref_j'] = $pref_j;
        $_SESSION['city_j'] = $city_j;
        $_SESSION['count']  = $count;
if (DEBUG)  {
    print "\$_SESSION[] = "; print_r($_SESSION); print "<br>\n";
}
    }
    $sql = $select_phrase . $where_clause 
         . " LIMIT " . RECORD_PER_PAGE
         . " OFFSET " . $page * RECORD_PER_PAGE;
    //
    //  ページ制御部分の表示
    //
    $pages = $count / RECORD_PER_PAGE;          //  ページ数
    if ($pages > 1) {
        print "検索結果ページ：";
        for ($i=0; $i<$pages; $i++) {
            if ($i == $page)    {
                printf(" %d\n", $i+1);
            } else  {
                printf(" <a href=\"{$_SERVER['PHP_SELF']}?page=%d\">%d</a>\n",
                    $i, $i+1);
            }
        }
        if ($page+1 < $pages) {
            printf(
            " <a href=\"{$_SERVER['PHP_SELF']}?page=%d\">次ページ</a><br>\n",
            $page+1);
        }
    }

    if (DEBUG)  { print "$sql<br>\n";   }

    $stmt = $db->prepare($sql);     //  SQL発行準備
    $stmt->execute();               //  SQL実行
    $count = 0;                     //  取得済みレコード件数
    while ($row = $stmt->fetch(PDO::FETCH_ASSOC))  {
        if ($count == 0)    {
            print "<table border>\n"
                . "<tr><th>郵便番号<th>都道府県<th>市区町村<th>町域</tr>\n";
        }
        printf("<tr><td>%s<td>%s<td>%s<td>%s</tr>\n",
            $row['zip7'], $row['pref_j'], $row['city_j'], $row['town_j']);
        $count++;
    }
    if ($count > 0) {
        print("</table>\n");
    } else  {
        print "該当するデータはありません。\n";
    }
    print "</body></html>";
}   //  zip_display();
?>
